/* src/stack.h */
/*
 * OCSP responder
 * by Massimiliano Pala (madwolf@openca.org)
 * OpenCA Licensed Software
 *
 * Copyright (c) 2001-2006 The OpenCA Project.  All rights reserved.
 *
 * ====================================================================
 *
 * This product includes cryptographic software written by Eric Young
 * (eay@cryptsoft.com).  This product includes software written by Tim
 * Hudson (tjh@cryptsoft.com).
 *
 */

#ifndef __STACK_H
#define __STACK_H

typedef struct stack_node_st {
	struct stack_node_st *next;
	struct stack_node_st *prev;

	void *data;
} STACK_NODE;

typedef struct stack_st {
	int elements;

	STACK_NODE *head;
	STACK_NODE *tail;
} STACK;


STACK * STACK_new( void );
int     STACK_free ( STACK * st );
int     STACK_elements ( STACK *st );

int    STACK_push ( STACK *st, void *obj );

void  * STACK_pop ( STACK *st );
void  * STACK_get_num ( STACK *st, int num );

int     STACK_ins_num ( STACK *st, int num, void *obj );
int     STACK_del_num ( STACK *st, int num );

#define STACK_OK		0
#define STACK_ERR		-1

#define STACK_X509_push( STACK, obj ) STACK_push( STACK, (void *) obj)
#define STACK_X509_pop(STACK) (X509 *)STACK_pop( STACK )

#endif

